﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BasicEnemyMovement : MonoBehaviour
{

    [SerializeField] private Transform target;
    public Vector3 waypoint;
    public float leash = 20f;
    public float wanderingSpeed = 10f;
    public float pursueSpeed = 30f;
    public float patrolRange = 30f;

    public bool hasFired;

    //start wandering as soon as it loads
    void Start()
    {
        target = GameObject.FindGameObjectWithTag("Player").GetComponent<Transform>();
        Wander();
    }

    void Update()
    {
        //if u EVER fire your gun, all the zombies will know where u are and get hella agrro
        hasFired = GameObject.FindGameObjectWithTag("Player").GetComponent<WeaponAttack>().firedGun;

        //if the player and zombie get close enough (making a leash range w/o using a trigger)
        if ((transform.position - target.position).magnitude < leash || hasFired)   //magnitude is the hypotenuse of the trianlge we make between the player and zombie
        {
            //chase down the player
            Pursue();
            //otherwise check if we're at our random destination
        } else if ((transform.position - waypoint).magnitude < 5)
        {
            //if we are, choose a new one
            Wander();
            //if we are not...
        } else
        {
            //keep walking
            transform.position = Vector2.MoveTowards(transform.position, waypoint, wanderingSpeed * Time.deltaTime);
        }
    }

    public void Wander()
    {
        waypoint = new Vector3(Random.Range(transform.position.x - patrolRange, transform.position.x + patrolRange),
            Random.Range(transform.position.y - patrolRange, transform.position.y + patrolRange), 0f);
        transform.LookAt(waypoint);
        transform.Rotate(0, -90, 0);    // just like with the player, the hands are 90 degress off always for some reason
    }

    public void Pursue()
    {
        transform.position = Vector2.MoveTowards(transform.position, target.position, pursueSpeed * Time.deltaTime);
        transform.LookAt(target);
        transform.Rotate(0, -90, 0);
    }
}
