﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class HealthBar : MonoBehaviour
{

    private Transform bar;
    private int hp;

    private float percentage;

    public GameObject player;

    void Start()
    {
        bar = transform.Find("ActualHealth");
        hp = player.GetComponent<PlayerStats>().GetCurHP();
        bar.localScale = new Vector3(hp, 1f);
    }

    // Update is called once per frame
    void Update()
    {
        SetSize(FindHealthBarScale());
    }

    void SetSize(float sizeNormalized)
    {
        bar.localScale = new Vector3(sizeNormalized, 1f);
    }

    private float FindHealthBarScale()
    {
        float mHP = (float) player.GetComponent<PlayerStats>().GetMaxHP();
        float cHP = (float) player.GetComponent<PlayerStats>().GetCurHP();
        float ratio = cHP / mHP;
        return 7 * ratio;
    }
}
