﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Pickup : MonoBehaviour
{
    public Image customImage;
    public Image needKey;
    

    private int interactCase;
    // 1 = ammo;
    // 2 = wood;
    // 3 = stone;
    // 4 = scrap;
    // 5 = key;
    // 6 = treasure;
    // 7 = healtpack; //forgot about this one

    //public string interactable;

    public GameObject player;
    public CircleCollider2D circle;
    [SerializeField] private Collider2D interactable;

    // Update is called once per frame
    void Update()
    {
        if (Input.GetKeyDown(KeyCode.E) && customImage.enabled == true)
        {
            if (interactCase != 6)
            {
                switch (interactCase)
                {
                    case 1:
                        player.GetComponent<PlayerStats>().IncreaseAmmo(10);
                        break;
                    case 2:
                        player.GetComponent<PlayerStats>().SetWood(1);
                        break;
                    case 3:
                        player.GetComponent<PlayerStats>().SetStone(1);
                        break;
                    case 4:
                        player.GetComponent<PlayerStats>().SetScrap(1);
                        break;
                    case 5:
                        player.GetComponent<PlayerStats>().SetKey(1);
                        break;
                    case 7:
                        Debug.Log("Case 7 called");
                        player.GetComponent<PlayerStats>().SetHP(25);
                        break;
                }
                PickupPickup(interactCase);
            }
            else
            {
                HaveKey();
            }
        }
    }

    void HaveKey()
    {
        if (player.GetComponent<PlayerStats>().GetKey() > 0)
        {
            player.GetComponent<PlayerStats>().IncreaseAmmo(20);
            player.GetComponent<PlayerStats>().SetWood(20);
            player.GetComponent<PlayerStats>().SetStone(20);
            player.GetComponent<PlayerStats>().SetScrap(20);
            player.GetComponent<PlayerStats>().SetKey(-1);
            PickupPickup(interactCase);
        } else
        {
            needKey.enabled = true;
        }
    }

    private void OnTriggerEnter2D(Collider2D other)
    {
        if (other.CompareTag("Interactable")) {
            if (other.name.Equals("Pickup_treasure") && player.GetComponent<PlayerStats>().GetKey() == 0)
            {
                needKey.enabled = true;
                interactable = other;
            } else
            {
                customImage.enabled = true;
                interactable = other;
                DetermineInteractable(other);
            }
        }
    }

    private void OnTriggerExit2D(Collider2D other)
    {
        if (other.CompareTag("Interactable")) {
            customImage.enabled = false;
            needKey.enabled = false;
            interactable = null;
        }
    }

    void DetermineInteractable(Collider2D other)
    {
        /*
        if (other.gameObject.name == "Ammo")
        {
            interactCase = 1;
        }
        */
        switch (other.gameObject.name)
        {
            case "Pickup_bullet":
                interactCase = 1;
                break;
            case "Pickup_bullet(Clone)":
                interactCase = 1;
                break;
            case "Pickup_wood":
                interactCase = 2;
                break;
            case "Pickup_wood(Clone)":
                interactCase = 2;
                break;
            case "Pickup_stone":
                interactCase = 3;
                break;
            case "Pickup_stone(Clone)":
                interactCase = 3;
                break;
            case "Pickup_scrap":
                interactCase = 4;
                break;
            case "Pickup_scrap(Clone)":
                interactCase = 4;
                break;
            case "Pickup_key":
                interactCase = 5;
                break;
            case "Pickup_key(Clone)l":
                interactCase = 5;
                break;
            case "Pickup_treasure":
                interactCase = 6;
                break;
            case "Pickup_healthpack":
                interactCase = 7;
                break;
        }
    }

    //destroy instance of pickup since you used it.
    void PickupPickup(int caseNumber)
    {
        if (caseNumber == 7)
        {
            if (player.GetComponent<PlayerStats>().GetCurHP() == player.GetComponent<PlayerStats>().GetMaxHP())
            {
                Debug.Log("You're already full");
            }
            else
            {
                Destroy(interactable.gameObject);
                interactable = null;
            }
        }
        else
        {
            Destroy(interactable.gameObject);
            interactable = null;
        }

        
    }

}
