﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerAnimator : MonoBehaviour
{
    private Animator anim;
    private PlayerStats playerStats;

    void Start()
    {
        anim = GetComponent<Animator>();
        playerStats = GetComponent<PlayerStats>();
    }

    void Update()
    {
        MovementAnimations();
    }

    void MovementAnimations()
    {
        if ((Input.GetKey(KeyCode.W) || Input.GetKey(KeyCode.S) || Input.GetKey(KeyCode.D) || Input.GetKey(KeyCode.A)) && Input.GetKey(KeyCode.LeftShift))
        {
            if (playerStats.GetCurStamina() > 0)    //otherwise animation check is independant of player's actual ability to sprint (animation runs even tho not sprinting)
            {
                anim.SetBool("isWalking", false);
                anim.SetBool("isSprinting", true);
            } else
            {
                anim.SetBool("isWalking", true);
                anim.SetBool("isSprinting", false);
            }
        }
        else if (Input.GetKey(KeyCode.W) || Input.GetKey(KeyCode.S) || Input.GetKey(KeyCode.D) || Input.GetKey(KeyCode.A))
        {
            anim.SetBool("isWalking", true);
            anim.SetBool("isSprinting", false);
        }
        else
        {
            anim.SetBool("isWalking", false);
            anim.SetBool("isSprinting", false);
        }
    }

    public void SwingAxe()
    {
        Debug.Log("Swing Axe called, its the fucking bools that dont work");
        anim.SetTrigger("Swing");
    }

    public void FireRifle()
    {
        Debug.Log("Rifle Fired");
        anim.SetTrigger("Fire");
        Chamber();
    }

    public void Chamber()
    {
        Debug.Log("Chambered Round");
        anim.SetTrigger("Chamber");
        CycleComplete();
    }

    public void CycleComplete()
    {
        Debug.Log("Cycle Complete");
        anim.SetTrigger("CycleComplete");
    }

    public void holdingGun(bool boolean)
    {
        if (boolean)
        {
            anim.SetBool("holdingGun", true);
        } else
        {
            anim.SetBool("holdingGun", false);
        }
    }
}